{
  MACAL (Mass Calculator)
  Copyright (C) 2007, Innsbruck Medical University

  Author: Stefan Ascher <stefan.ascher@i-med.ac.at>

  $Id: frmMain.pas,v 1.34 2007/11/09 09:12:40 q002sa Exp $
}

unit frmMain;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
  LCLIntf, LCLType, LMessages,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ComCtrls, ExtCtrls, Grids, StdCtrls, Spin, Menus, uSequence, uMasses, uMods,
  uTermMod, Buttons, Dialogs, TransparentWnd;

type
  TMainForm = class(TForm)
    pcMain: TPageControl;
    TabSheet4: TTabSheet;
    spnDecimals: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    popSequence: TPopupMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    Selectall1: TMenuItem;
    popResult: TPopupMenu;
    Copy2: TMenuItem;
    TabSheet3: TTabSheet;
    lblProductName: TLabel;
    lblProductDescr: TLabel;
    lblProductVersion: TLabel;
    lblProductCopyright: TLabel;
    txtProtonMass: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    TabSheet5: TTabSheet;
    txtComposition: TMemo;
    Panel2: TPanel;
    rgCompMassType: TRadioGroup;
    Label10: TLabel;
    txtCompRes: TEdit;
    popComp: TPopupMenu;
    Cut2: TMenuItem;
    Copy3: TMenuItem;
    Paste2: TMenuItem;
    MenuItem6: TMenuItem;
    SelectAll2: TMenuItem;
    TabSheet6: TTabSheet;
    Panel3: TPanel;
    Panel4: TPanel;
    Splitter2: TSplitter;
    sgRes: TStringGrid;
    Label3: TLabel;
    txtMass: TEdit;
    Label4: TLabel;
    txtLength: TEdit;
    pnlResult: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    rgMassType: TRadioGroup;
    cboNTerm: TComboBox;
    cboCTerm: TComboBox;
    rgSpecies: TRadioGroup;
    Splitter1: TSplitter;
    txtSequence: TRichEdit;
    Label11: TLabel;
    spnChargeCount: TSpinEdit;
    Label13: TLabel;
    imgLogo: TImage;
    btnCopyComp: TSpeedButton;
    N1: TMenuItem;
    miOpenSequence: TMenuItem;
    miSaveSequence: TMenuItem;
    N3: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    chkRememberWindow: TCheckBox;
    lvMods: TListView;
    Splitter3: TSplitter;
    chkOnTop: TCheckBox;
    tbTransparency: TTrackBar;
    chkClickThrough: TCheckBox;
    popMods: TPopupMenu;
    Load1: TMenuItem;
    odMods: TOpenDialog;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure txtSequenceChange(Sender: TObject);
    procedure txtSequenceKeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rgMassTypeClick(Sender: TObject);
    procedure pcMainChange(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure popSequencePopup(Sender: TObject);
    procedure cboNTermClick(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure txtCompositionChange(Sender: TObject);
    procedure txtCompositionKeyPress(Sender: TObject; var Key: Char);
    procedure popCompPopup(Sender: TObject);
    procedure Cut2Click(Sender: TObject);
    procedure Copy3Click(Sender: TObject);
    procedure Paste2Click(Sender: TObject);
    procedure SelectAll2Click(Sender: TObject);
    procedure spnChargeCountChange(Sender: TObject);
    procedure txtCompositionDblClick(Sender: TObject);
    procedure txtSequenceMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnCopyCompClick(Sender: TObject);
    procedure miOpenSequenceClick(Sender: TObject);
    procedure miSaveSequenceClick(Sender: TObject);
    procedure chkOnTopClick(Sender: TObject);
    procedure tbTransparencyChange(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lvModsChanging(Sender: TObject; Item: TListItem;
      Change: TItemChange; var AllowChange: Boolean);
    procedure lvModsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure txtProtonMassKeyPress(Sender: TObject; var Key: Char);
    procedure txtSearchMassKeyPress(Sender: TObject; var Key: Char);
    procedure rgSpeciesClick(Sender: TObject);
  private
    { Private declarations }
    fSequence: TSequence;
    fTermMod: TTermModList;
    fMasses: TMassList;
    fProtonMass: double;
    fReformat: boolean;
    fTransparentWnd: TTransparentWnd;
    fSavedCheckedState: boolean;
    fConfigFile: string;
    procedure SetupResGrid;
    procedure CalcResults;
    procedure ShowMods;
    procedure Paste;
    procedure InitTerms;
    procedure ReadSettings;
    procedure WriteSettings;
    procedure FormatSequence;
    procedure FormatChar(const AChar: Char);
    procedure CalcComposition;
    procedure PasteComp;
    procedure miMod_Click(Sender: TObject);
    procedure UpdateModMenu;
    procedure SetOnTop(b: boolean);
    procedure ShowHelp;
    function GetConfigFile: string;
    procedure HandleCommandLine;
  protected
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
{$IFNDEF FPC}
  ShellApi,
{$ELSE}
{$ENDIF}
  ClipBrd, IniFiles, ShlObj, ActiveX, Math;

const
  DefProtonMass = 1.00727647;

function GetVersionString(FileName: string; VerStr: string): string;
{ This is the function to get the FileVersionInfo }
var
  Size    : DWORD;
  Handle  : DWORD;
  Len     : UINT;
  Buffer  : PChar;
  Value   : PChar;
  TransNo : PLongInt;
  SFInfo  : string;
begin
{ Possible for VerStr:
 CompanyName
 FileDescription
 FileVersion
 InternalName
 LegalCopyright
 LegalTradeMarks
 OriginalFilename
 ProductName
 ProductVersion
 Comments
}
  Result := '';
  Size := GetFileVersionInfoSize(PChar(FileName), Handle);
  if Size > 0 then begin
    Buffer := AllocMem(Size);
    try
      GetFileVersionInfo(PChar(FileName), 0, Size, Buffer);
      VerQueryValue(Buffer, PChar('VarFileInfo\Translation'),
                     Pointer(TransNo), Len);
      SFInfo := Format('%s%.4x%.4x%s%s%', ['StringFileInfo\',
        LoWord(TransNo^), HiWord(Transno^), '\', VerStr]);
      if VerQueryValue(Buffer, PChar(SFInfo),
                      Pointer(Value), Len) then
        Result := Value;
    finally
      { always release memory }
      if Assigned(Buffer) then
        FreeMem(Buffer, Size);
    end;
  end;
end;

function SpecialFolderLocation(const ACSIDL: integer): string;
var
  pidl: PItemIDList;
  Buffer: array[0..MAX_PATH-1] of Char;
  Malloc: IMalloc;
begin
  Result := '';
  if FAILED(SHGetMalloc(Malloc)) then
    Malloc := nil;
  if SUCCEEDED(SHGetSpecialFolderLocation(0, ACSIDL, pidl)) then begin
    if SHGetPathFromIDList(pidl, Buffer) then
      Result := Buffer;
    if Assigned(Malloc) then
      Malloc.Free(pidl);
  end;
end;

function TMainForm.GetConfigFile: string;
var
  d: string;
begin
  if fConfigFile = '' then begin
    d := SpecialFolderLocation(CSIDL_APPDATA);
    fConfigFile := IncludeTrailingBackslash(d) + 'macal.ini';
  end;
  Result := fConfigFile;
end;

procedure TMainForm.CalcResults;
var
  i: integer;
  m, nt, ct, d: double;
  t: TMod;
begin
  if cboNTerm.ItemIndex <> -1 then begin
    t := TMod(cboNTerm.Items.Objects[cboNTerm.ItemIndex]);
    nt := t.Mass;
  end else
    nt := 0.0;

  if cboCTerm.ItemIndex <> -1 then begin
    t := TMod(cboCTerm.Items.Objects[cboCTerm.ItemIndex]);
    ct := t.Mass;
  end else
    ct := 0.0;

  m := fSequence.Mass;
  if m <> 0.0 then
    m := m + nt + ct;
  txtMass.Text := Format('%.' + IntToStr(spnDecimals.Value) + 'f', [m]);
  txtLength.Text := IntToStr(fSequence.Length);
  for i := 1 to sgRes.RowCount - 1 do begin
    if m <> 0.0 then begin
      if rgSpecies.ItemIndex = 0 then
        d := (m/i) + fProtonMass
      else
        d := (m/i) - fProtonMass;
    end else
      d := 0;
    sgRes.Cells[1, i] := Format('%.' + IntToStr(spnDecimals.Value) + 'f', [d]);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  with Constraints do begin
    MinHeight := Height;
    MinWidth := width;
  end;
  fTransparentWnd := TTransparentWnd.Create(Self);
  fTransparentWnd.AutoOpaque := true;
  fTransparentWnd.SetTransparent(0);
  tbTransparency.Visible := fTransparentWnd.Enabled;
  chkClickThrough.Visible := fTransparentWnd.Enabled;
  fReformat := false;
  pcMain.ActivePageIndex := 0;
  ActiveControl := txtSequence;
  fSequence := TSequence.Create;
  fTermMod := TTermModList.Create;
  fMasses := TMassList.Create;

  imgLogo.Picture.Icon := Application.Icon;
  lblProductName.Caption := GetVersionString(ParamStr(0), 'ProductName');
  lblProductDescr.Caption := '(' + GetVersionString(ParamStr(0), 'FileDescription') + ')';
  lblProductVersion.Caption := 'Version ' + GetVersionString(ParamStr(0), 'FileVersion');
  lblProductCopyright.Caption := GetVersionString(ParamStr(0), 'LegalCopyright') +
    ', ' + GetVersionString(ParamStr(0), 'CompanyName');

  HandleCommandLine;    
  ReadSettings;
  SetupResGrid;

  UpdateModMenu;
    
  fSequence.MassType := TMassType(rgMassType.ItemIndex);
  fTermMod.MassType := TMassType(rgMassType.ItemIndex);
  fMasses.MassType := TMassType(rgCompMassType.ItemIndex);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  fSequence.Free;
  fTermMod.DeleteAll;
  fTermMod.Free;
  fMasses.DeleteAll;
  fMasses.Free;
end;

procedure TMainForm.ShowMods;
var
  i: integer;
  m: TMod;
  t: string;
  li: TListItem;
begin
  if lvMods.Items.Count <> 0 then begin
    for i := 0 to Min(lvMods.Items.Count, fSequence.Mods.Count) - 1 do begin
      TMod(fSequence.Mods[i]).Selected := lvMods.Items[i].Checked;
    end;
  end;
  lvMods.Items.BeginUpdate;
  try
    lvMods.Items.Clear;
    for i := 0 to fSequence.Mods.Count - 1 do begin
      li := lvMods.Items.Add;
      m := TMod(fSequence.Mods[i]);
      li.Caption := m.NameChar;
      li.SubItems.Add(m.Name);
      li.SubItems.Add(m.Residues);
      li.SubItems.Add(FloatToStr(m.MassMono));
      li.SubItems.Add(FloatToStr(m.MassAvg));
      li.Checked := m.Selected;
      li.Data := m;
      t := '';
      if (tN in m.Termini) then
        t := t + 'N';
      if (tC in m.Termini) then
        t := t + 'C';
      li.SubItems.Add(t);
    end;
  finally
    lvMods.Items.EndUpdate;
  end;
end;

procedure TMainForm.SetupResGrid;
var
  i: integer;
begin
  sgRes.Rows[0][1] := 'Mass';
  sgRes.ColWidths[0] := 50;
  sgRes.ColWidths[1] := 100;
  for i := 1 to sgRes.RowCount - 1 do begin
    sgRes.Rows[i][0] := Format('MH%d+', [i]);
  end;
end;

procedure TMainForm.txtSequenceChange(Sender: TObject);
begin
  fSequence.Sequence := txtSequence.Text;
  CalcResults;
end;

procedure TMainForm.txtSequenceKeyPress(Sender: TObject; var Key: Char);
  procedure Err;
  begin
    MessageBeep(MB_ICONEXCLAMATION);
    Key := #0;
  end;
var
  m: TMod;
  s: integer;
  aa: Char;
  txt: string;
begin
  if Key <> #8 then begin
    Key := UpCase(Key);
    m := TMod(fSequence.Mods.Find(Key));
    if ((m = nil) or m.Fixed) and (fSequence.AAs.Find(Key) = nil) then begin
      Err;
    end else begin
      if (Assigned(m)) then begin
        s := txtSequence.SelStart;
        txt := txtSequence.Text;
        if (s <> 0) and (s <= Length(txt)) then begin
          aa := txt[s];
          if Pos(aa, m.Residues) = 0 then begin
            Err;
            Exit;
          end;
        end;
      end;
      FormatChar(Key);
    end;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  CalcResults;
end;

procedure TMainForm.rgMassTypeClick(Sender: TObject);
begin
  rgMassType.ItemIndex := (Sender as TRadioGroup).ItemIndex;
  rgCompMassType.ItemIndex := (Sender as TRadioGroup).ItemIndex;

  fSequence.MassType := TMassType((Sender as TRadioGroup).ItemIndex);
  fTermMod.MassType := TMassType((Sender as TRadioGroup).ItemIndex);
  fMasses.MassType := TMassType((Sender as TRadioGroup).ItemIndex);
  CalcResults;
  CalcComposition;
end;

procedure TMainForm.pcMainChange(Sender: TObject);
begin
  if pcMain.ActivePageIndex = 0 then begin
    try
      fProtonMass := StrToMass(txtProtonMass.Text);
    except
      fProtonMass := DefProtonMass;
      txtProtonMass.Text := FloatToStr(fProtonMass);
    end;
    FormatSequence;
    CalcResults;
  end else if pcMain.ActivePageIndex = 1 then begin
    CalcComposition;
  end;
end;

procedure TMainForm.Cut1Click(Sender: TObject);
begin
  txtSequence.CutToClipboard;
end;

procedure TMainForm.Copy1Click(Sender: TObject);
begin
  txtSequence.CopyToClipboard;
end;

procedure TMainForm.Paste1Click(Sender: TObject);
begin
  Paste;
end;

procedure TMainForm.Selectall1Click(Sender: TObject);
begin
  txtSequence.SelectAll;
end;

procedure TMainForm.popSequencePopup(Sender: TObject);
begin
  Cut1.Enabled := txtSequence.SelText <> '';
  Copy1.Enabled := txtSequence.SelText <> '';
  Paste1.Enabled := Clipboard.AsText <> '';
  SelectAll1.Enabled := txtSequence.Text <> '';
end;

procedure TMainForm.Paste;
var
  txt, s: string;
  i: integer;
begin
  txt := UpperCase(Trim(Clipboard.AsText));
  s := '';
  for i := 1 to Length(txt) do begin
    if txt[i] = '.' then begin
      if i = 2 then
        s := ''
      else if i = Length(txt) - 1 then
        Break;
    end;
    if (fSequence.AAs.Find(txt[i]) <> nil) or (fSequence.Mods.Find(txt[i]) <> nil) then begin
      s := s + txt[i];
    end;
  end;
  txtSequence.SelText := s;
  fReformat := true;
  FormatSequence;
end;

procedure TMainForm.InitTerms;
var
  i: integer;
  m: TMod;
begin
  for i := 0 to fTermMod.Count - 1 do begin
    m := TMod(fTermMod[i]);
    if (tC in m.Termini) then
      cboCTerm.Items.AddObject(m.Name, m);
    if (tN in m.Termini) then
      cboNTerm.Items.AddObject(m.Name, m);
  end;
  cboNTerm.ItemIndex := 0;
  cboCTerm.ItemIndex := 0;
end;

procedure TMainForm.cboNTermClick(Sender: TObject);
begin
  CalcResults;
end;

procedure TMainForm.Copy2Click(Sender: TObject);
var
  r: integer;
  str: string;
begin
  r := sgRes.Row;
  str := sgRes.Cells[1, r];
  Clipboard.AsText := str;
end;

procedure TMainForm.ReadSettings;
var
  i: integer;
  l, t, w, h: integer;
  m: TMod;
  fn: string;
begin
  with TIniFile.Create(GetConfigFile) do try
    chkRememberWindow.Checked := ReadBool('options', 'rememberwindow', true);
    chkOnTop.Checked := ReadBool('options', 'ontop', false);
    SetOnTop(chkOnTop.Checked);
    chkClickThrough.Checked := ReadBool('options', 'clickthrough', false);
    tbTransparency.Position := ReadInteger('options', 'transaprency', 100);
    tbTransparencyChange(tbTransparency);
    if chkRememberWindow.Checked then begin
      l := ReadInteger('MainForm', 'Left', Left);
      t := ReadInteger('MainForm', 'Top', Top);
      w := ReadInteger('MainForm', 'Width', Width);
      h := ReadInteger('MainForm', 'Height', Height);
      if (w > 0) and (h > 0) then
        MoveWindow(Handle, l, t, w, h, false);
      pnlResult.Height := ReadInteger('MainForm', 'splitterh', pnlResult.Height);
      txtSequence.Height := ReadInteger('MainForm', 'splitterh2', txtSequence.Height);
      Panel4.Width := ReadInteger('MainForm', 'splitterv', Panel4.Width);
    end;

    try
      fProtonMass := ReadFloat('options', 'protonmass', DefProtonMass);
    except
      fProtonMass := DefProtonMass;
    end;
    txtProtonMass.Text := FloatToStr(fProtonMass);
    spnDecimals.Value := ReadInteger('options', 'decimals', 4);
    txtSequence.Font.Name := ReadString('options', 'font.name', txtSequence.Font.Name);
    txtSequence.SelAttributes.Name := txtSequence.Font.Name;
    txtSequence.Font.Size := ReadInteger('options', 'font.size', txtSequence.Font.Size);
    txtSequence.SelAttributes.Size := txtSequence.Font.Size;
    txtComposition.Font.Assign(txtSequence.Font);
    rgSpecies.ItemIndex := ReadInteger('settings', 'species', 0);
    rgMassType.ItemIndex := ReadInteger('settings', 'masstype', 1);
    rgMassTypeClick(rgMassType);
    spnChargeCount.Value := ReadInteger('settings', 'rescount', 30);

    fn := ReadString('options', 'aasfile', IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + AAS_FILE);
    if not FileExists(fn) then
      fn := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + AAS_FILE;
    fSequence.AAs.LoadFromFile(fn);
    fn := ReadString('options', 'modsfile', IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + MODS_FILE);
    if not FileExists(fn) then
      fn := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + MODS_FILE;
    fSequence.Mods.LoadFromFile(fn);
    fn := ReadString('options', 'termmodfile', IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + TERM_FILE);
    if not FileExists(fn) then
      fn := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + TERM_FILE;
    fTermMod.LoadFromFile(fn);
    fn := ReadString('options', 'massfile', IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + MASS_FILE);
    if not FileExists(fn) then
      fn := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + MASS_FILE;
    fMasses.LoadFromFile(fn);
    ShowMods;
    for i := 0 to lvMods.Items.Count - 1 do begin
      lvMods.Items[i].Checked := ReadBool('mods', IntToStr(i), false);
      m := TMod(lvMods.Items[i].Data);
      m.Selected := lvMods.Items[i].Checked;
    end;
    InitTerms;
    cboNTerm.ItemIndex := ReadInteger('settings', 'ntermindex', 0);
    cboCTerm.ItemIndex := ReadInteger('settings', 'ctermindex', 0);
  finally
    Free;
  end;
end;

procedure TMainForm.WriteSettings;
var
  i: integer;
  wp: TWindowPlacement;
begin
  with TIniFile.Create(GetConfigFile) do try
    WriteBool('options', 'rememberwindow', chkRememberWindow.Checked);
    WriteBool('options', 'ontop', chkOnTop.Checked);
    WriteBool('options', 'clickthrough', chkClickThrough.Checked);
    WriteInteger('options', 'transaprency', tbTransparency.Position);
    GetWindowPlacement(Handle, @wp);
    WriteInteger('MainForm', 'Left', wp.rcNormalPosition.Left);
    WriteInteger('MainForm', 'Top', wp.rcNormalPosition.Top);
    WriteInteger('MainForm', 'Width', wp.rcNormalPosition.Right - wp.rcNormalPosition.Left);
    WriteInteger('MainForm', 'Height', wp.rcNormalPosition.Bottom - wp.rcNormalPosition.Top);
    WriteInteger('Mainform', 'splitterh', pnlResult.Height);
    WriteInteger('MainForm', 'splitterh2', txtSequence.Height);
    WriteInteger('Mainform', 'splitterv', Panel4.Width);
    WriteFloat('options', 'protonmass', fProtonMass);
    WriteInteger('options', 'decimals', spnDecimals.Value);
    WriteString('options', 'font.name', txtSequence.Font.Name);
    WriteInteger('options', 'font.size', txtSequence.Font.Size);
    WriteString('options', 'modsfile', fSequence.Mods.Filename);
    WriteString('options', 'aasfile', fSequence.AAs.Filename);
    WriteString('options', 'termmodfile', fTermMod.Filename);
    WriteString('options', 'massfile', fMasses.Filename);
    EraseSection('mods');
    for i := 0 to lvMods.Items.Count - 1 do begin
      WriteBool('mods', IntToStr(i), lvMods.Items[i].Checked);
    end;
    WriteInteger('settings', 'ntermindex', Max(0, cboNTerm.ItemIndex));
    WriteInteger('settings', 'ctermindex', Max(0, cboCTerm.ItemIndex));
    WriteInteger('settings', 'species', rgSpecies.ItemIndex);
    WriteInteger('settings', 'masstype', rgMassType.ItemIndex);
    WriteInteger('settings', 'rescount', spnChargeCount.Value);
  finally
    Free;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WriteSettings;
end;

procedure TMainForm.FormatSequence;
var
  i: integer;
  m, m2: TMod;
  str: string;
  ss, sl: integer;
begin
  if not fReformat then Exit;
  
  str := txtSequence.Text;
  ss := txtSequence.SelStart;
  sl := txtSequence.SelLength;
  txtSequence.Lines.BeginUpdate;
  txtSequence.OnChange := nil;
  try
    for i := 1 to Length(str) do begin
      m := fSequence.Mods.GetFromAA(str[i]);
      txtSequence.SelStart := i-1;
      txtSequence.SelLength := 1;
      if Assigned(m) and m.Selected and m.Fixed then begin
        txtSequence.SelAttributes.Color := clBlue;
      end else begin
        m2 := TMod(fSequence.Mods.Find(str[i]));
        if (Assigned(m2)) then begin
          if m2.Selected then
            txtSequence.SelAttributes.Color := clGreen
          else
            txtSequence.SelAttributes.Color := clRed;
        end else begin
          txtSequence.SelAttributes.Color := clBlack;
        end;
      end;
    end;
  finally
    txtSequence.SelStart := ss;
    txtSequence.SelLength := sl;
    txtSequence.Lines.EndUpdate;
    txtSequence.OnChange := txtSequenceChange;
    fReformat := false;
  end;
end;

procedure TMainForm.FormatChar(const AChar: Char);
var
  m, m2: TMod;
begin
  if AChar = #0 then Exit;
  
  txtSequence.OnChange := nil;
  try
    m := fSequence.Mods.GetFromAA(AChar);
    if Assigned(m) and m.Selected and m.Fixed then begin
      txtSequence.SelAttributes.Color := clBlue;
    end else begin
      m2 := TMod(fSequence.Mods.Find(AChar));
      if (Assigned(m2)) then begin
        if m2.Selected then
          txtSequence.SelAttributes.Color := clGreen
        else
          txtSequence.SelAttributes.Color := clRed;
      end else begin
        txtSequence.SelAttributes.Color := clBlack;
      end;
    end;
  finally
    txtSequence.OnChange := txtSequenceChange;
  end;
end;

procedure TMainForm.CalcComposition;
var
  sfac: string;
  neg: boolean;
  res: double;
  e: TMass;

  procedure AddE;
  var
    m: double;
    fac: integer;
  begin
    if Assigned(e) then begin
      if sfac = '' then
        fac := 1
      else
        fac := StrToInt(sfac);
      m := e.Mass * fac;
      if neg then
        m := -m;
      res := res + m;
      e := nil;
      neg := false;
    end;
  end;

var
  str: string;
  i: integer;
begin
  try
    str := txtComposition.Text;
    neg := false;
    res := 0.0;
    e := nil;
    sfac := '';
    for i := 1 to Length(str) do begin
      case str[i] of
        '-':
          begin
            AddE;
            neg := not neg;
            sfac := '';
          end;
        '+':
          begin
            AddE;
            sfac := '';
          end;
        '0'..'9':
          begin
            sfac := sfac + str[i];
          end;
        else begin
          AddE;
          sfac := '';
          e := fMasses.Find(str[i]);
        end;
      end;
    end;
    AddE;
    txtCompRes.Text := Format('%.' + IntToStr(spnDecimals.Value) + 'f', [res]);
  except
    Application.MessageBox('Invalid Formula', 'Error', MB_ICONSTOP);
    txtCompRes.Text := Format('%.' + IntToStr(spnDecimals.Value) + 'f', [0.0]);
  end;
end;

procedure TMainForm.txtCompositionChange(Sender: TObject);
begin
  CalcComposition;
end;

procedure TMainForm.txtCompositionKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key in ['0'..'9', #8, '-', '+']) then Exit;

  Key := UpCase(Key);
  if (fMasses.Find(Key) = nil) then begin
    MessageBeep(MB_ICONEXCLAMATION);
    Key := #0;
  end;
end;

procedure TMainForm.popCompPopup(Sender: TObject);
begin
  Cut2.Enabled := txtComposition.SelText <> '';
  Copy3.Enabled := txtComposition.SelText <> '';
  Paste2.Enabled := Clipboard.AsText <> '';
  SelectAll2.Enabled := txtComposition.Text <> '';
end;

procedure TMainForm.Cut2Click(Sender: TObject);
begin
  txtComposition.CutToClipboard;
end;

procedure TMainForm.Copy3Click(Sender: TObject);
begin
  txtComposition.CopyToClipboard;
end;

procedure TMainForm.Paste2Click(Sender: TObject);
begin
  PasteComp;
end;

procedure TMainForm.SelectAll2Click(Sender: TObject);
begin
  txtComposition.SelectAll;
end;

procedure TMainForm.PasteComp;
var
  str, r: string;
  i: integer;
begin
  str := Clipboard.AsText;
  r := '';
  for i := 1 to Length(str) do begin
    if (str[i] in ['0'..'9', #8, '-', '+']) or (fMasses.Find(str[i]) <> nil) then
      r := r + str[i];
  end;
  txtComposition.SelText := r;
end;

procedure TMainForm.spnChargeCountChange(Sender: TObject);
begin
  sgRes.RowCount := spnChargeCount.Value+1;
  SetupResGrid;
end;

procedure TMainForm.txtCompositionDblClick(Sender: TObject);
begin
  txtComposition.SelectAll;
end;

procedure TMainForm.txtSequenceMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssDouble in Shift then
    txtSequence.SelectAll;
end;

procedure TMainForm.btnCopyCompClick(Sender: TObject);
begin
  Clipboard.AsText := txtCompRes.Text;
end;

procedure TMainForm.miMod_Click(Sender: TObject);
var
  s: integer;
  txt: string;
  m: TMod;
  aa: Char;
begin
  s := txtSequence.SelStart;
  txt := txtSequence.Text;
  m := TMod(fSequence.Mods[(Sender as TMenuItem).Tag-1]);
  if (s <> 0) and (s <= Length(txt)) then begin
    aa := txt[s];
    if Pos(aa, m.Residues) = 0 then begin
      MessageBeep(MB_ICONEXCLAMATION);
      Exit;
    end else begin
      FormatChar(m.NameChar);
      txtSequence.SelText := m.NameChar;
    end;
  end;
end;

procedure TMainForm.miOpenSequenceClick(Sender: TObject);
begin
  if OpenDialog.Execute then begin
    fSequence.LoadFromFasta(OpenDialog.Filename);
    txtSequence.Text := fSequence.Sequence;
    fReformat := true;
    FormatSequence;
  end;
end;

procedure TMainForm.miSaveSequenceClick(Sender: TObject);
begin
  if SaveDialog.Execute then begin
    fSequence.SaveToFasta(SaveDialog.Filename);
  end;
end;

procedure TMainForm.UpdateModMenu;
var
  i: integer;
  mi: TMenuItem;
begin
  for i := popSequence.Items.Count - 1 downto 0 do begin
    if popSequence.Items[i].Tag <> 0 then
      popSequence.Items.Delete(i);
  end;
  for i := 0 to fSequence.Mods.Count - 1 do begin
    with TMod(fSequence.Mods[i]) do begin
      if not Fixed and Selected then begin
        mi := TMenuItem.Create(popSequence);
        mi.Caption := NameChar + ' - ' + Name;
        mi.Tag := i+1;
        mi.OnClick := miMod_Click;
        popSequence.Items.Add(mi);
      end;
    end;
  end;
end;

procedure TMainForm.SetOnTop(b: boolean);
begin
  if b then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED);
  end else begin
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED);
  end;
end;

procedure TMainForm.chkOnTopClick(Sender: TObject);
begin
  SetOnTop(chkOnTop.Checked);
end;

procedure TMainForm.tbTransparencyChange(Sender: TObject);
begin
  fTransparentWnd.SetTransparent(100 - tbTransparency.Position);
end;

procedure TMainForm.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_ACTIVATEAPP:
      begin
        if chkClickThrough.Checked then begin
          fTransparentWnd.SetClickThroughWnd(Handle, Message.WParam = 0);
        end;
      end;
  end;
  inherited;
end;

procedure TMainForm.Load1Click(Sender: TObject);
begin
  if FileExists(fSequence.Mods.Filename) then
    odMods.FileName := fSequence.Mods.Filename;
  if odMods.Execute then begin
    fSequence.Mods.LoadFromFile(odMods.FileName);
    ShowMods;
    fReformat := true;
    FormatSequence;
    CalcResults;
  end;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  Clipboard.AsText := txtMass.Text;
end;

procedure TMainForm.ShowHelp;
begin
   ShellExecute(0, 'open', PChar(IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + 'readme.txt'), nil, nil, SW_SHOWNORMAL);
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F1 then
    ShowHelp;
end;

procedure TMainForm.lvModsChanging(Sender: TObject; Item: TListItem;
  Change: TItemChange; var AllowChange: Boolean);
begin
  if (Change = ctState) then begin
    fSavedCheckedState := Item.Checked
  end;
end;

procedure TMainForm.lvModsChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  m: TMod;
begin
  if (Change = ctState) and (fSavedCheckedState <> Item.Checked) then begin
    m := TMod(Item.Data);
    if Assigned(m) then begin
      m.Selected := Item.Checked;
      UpdateModMenu;
      fReformat := true;
      FormatSequence;
      CalcResults;
    end;
  end;
end;

procedure TMainForm.txtProtonMassKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', FormatSettings.DecimalSeparator, #8]) then
    Key := #0;
end;

procedure TMainForm.HandleCommandLine;
var
  i: integer;
begin
  i := 1;
  while i <= ParamCount do begin
    if SameText(ParamStr(i), '-ini') then begin
      Inc(i);
      fConfigFile := ParamStr(i);
    end;
    Inc(i);
  end;
end;

procedure TMainForm.txtSearchMassKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', FormatSettings.DecimalSeparator, #8]) then
    Key := #0;
end;

procedure TMainForm.rgSpeciesClick(Sender: TObject);
begin
  CalcResults;
end;

end.
