{
  MACAL (Mass Calculator)
  Copyright (C) 2007, Innsbruck Medical University

  Author: Stefan Ascher <stefan.ascher@i-med.ac.at>

  $Id: uTermMod.pas,v 1.3 2007/04/05 07:51:00 q002sa Exp $
}

unit uTermMod;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  SysUtils, Classes, uMasses, uMods;

type
  TTermModList = class(TModList)
  public
    procedure LoadFromFile(const AFilename: string); override;
  end;

const
  TERM_FILE = 'term.ini';

implementation

procedure TTermModList.LoadFromFile(const AFilename: string);
var
  sl: TStringList;
  i, p1: integer;
  str, str2: string;
  aa: TMod;
  t: TTermini;
begin
  fFilename := AFilename;
  Clear;
  if not FileExists(AFilename) then Exit;
  sl := TStringList.Create;
  try
    sl.LoadFromFile(AFilename);
    for i := 0 to sl.Count - 1 do begin
      str := Trim(sl[i]);
      if (str <> '') and (str[1] <> ';') then begin
        aa := TMod.Create(Self);
        Add(aa);
        aa.Selected := true;
        p1 := Pos(';', str);
        if p1 = 0 then
          Continue;
        aa.Name := Copy(str, 1, p1-1);
        System.Delete(str, 1, p1);

        p1 := Pos(';', str);
        if (p1 = 0) then
          Continue;
        str2 := Copy(str, 1, p1-1);
        aa.Composition := str2;

        System.Delete(str, 1, p1);
        p1 := Pos(';', str);
        if (p1 = 0) then
          Continue;
        str2 := Copy(str, 1, p1-1);
        aa.MassMono := StrToMass(str2);

        System.Delete(str, 1, p1);
        p1 := Pos(';', str);
        if (str = '') then
          Continue;
        str2 := Copy(str, 1, p1-1);
        aa.MassAvg := StrToMass(str2);

        System.Delete(str, 1, p1);
        p1 := Pos(';', str);
        if (p1 = 0) then
          Continue;
        str2 := Copy(str, 1, p1-1);
        t := [];
        if Pos('N', str2) <> 0 then
          Include(t, tN);
        if Pos('C', str2) <> 0 then
          Include(t, tC);
        aa.Termini := t;
        
      end;
    end;
  finally
    sl.Free;
  end;
end;

end.
